Subject: Re: Large TLBs on 40x

From: Matt Porter <[email-masked]>
Date: Wed, 4 Aug 2004 09:39:37 -0700

On Wed, Aug 04, 2004 at 12:36:56PM -0400, Dan Malek wrote:
>
> On Aug 4, 2004, at 7:49 AM, Josh Boyer wrote:
>
> > Maybe pinning a read-only TLB entry for most of the text pages for
> > however large you can get would work...  or maybe not.
>
> The problem is BATs and pinned TLBs require alignment restrictions
> that don't allow this.
>
> > .....But when someone is writing new drivers, randomly poking
> > holes in the kernel text pages and then executing instructions from
> > there leads to some strange panics.  Although, the new driver should be
> > suspect in that case anyway :).
>
> Then, on MPC8xx don't select pinned TLBs to cover the kernel
> space, and on traditional PPC MMUs select  the 'nobat' option
> on the command line.  This will write protect the kernel text pages.
> However, if you select something like CONFIG_KGDB, this will
> allow writing of the text pages to set breakpoints.  You will need
> to use a debugger like the BDI2000 and use hardware breakpoints
> to do your debugging.  When you are done, you can enable the
> performance TLB options again.  I thought the 4xx allowed
> something like this as well.  If not, it could and probably should.

We eagerly await your patch. ;)

-Matt

** Sent via the linuxppc-embedded mail list. See http://lists.linuxppc.org/